<?php
/*
Plugin Name: Media-Filter
Plugin URI: http://082net.com/tag/media-filter
Description: 글 작성시 동영상 삽입을 쉽게 할 수있도록 도와주는 플러그인 입니다. GoogleVideo, YouTube, Mncast, Daum(tvpot) 등의 FLV 동영상을 지원하며, 일반적인 동영상(wmv, mov, swf 등)의 삽입도 지원합니다. 이 플러그인은 <a href="http://www.coolcode.cn/?p=100">coolplayer</a> v3.5 에 기반을 두고 있습니다. 자세한 사용법은 플러그인페이지를 참고하세요.
Version: 0.1
Author: Cheon, Yong-Min
Author URI: http://082net.com/
*/

class WpMediaFilter {
	//You can change options below
	// START Options
	var $width = 320;	 // 플레이어 너비 기본값
	var $height = 280;	// 플레이어 높이 기본값
	var $autostart = 0;	 // 0: 자동재생 안함 , 1: 자동재생 함
	var $use_html_tag = false;	 //<act></act> 태그를 사용하려면 true 로 설정
	// END Options
	var $preset = array('d1', 'd2', 'd3', 'd4', 'gv', 'yt', 'yt2', 'mnc');
	var $pre_url = array(
		'd1' => 'http://controller.tvpot.media.daum.net/mflvPlayer.swf?vid=',
		'd2' => 'http://flvs.daum.net/flvPlayer.swf?vid=',
		'd3' => 'http://flvs.daum.net/sflvPlayer_full.swf?vid=',
		'd4' => 'http://photo-tvpot.hanmail.net/player/cdn/flvPlayer.swf?video=',
		'gv' => 'http://video.google.com/googleplayer.swf?docId=',
		'yt' => 'http://www.youtube.com/v/',
		'yt2' => 'http://www.youtube.com/?v=',
		'mnc' =>'http://dory.mncast.com/mncHMovie.swf?movieID='
	);

	function WpMediaFilter() {
		// change below line for default media URL (No trailing slash)
		$this->base = get_settings('siteurl') . "/wp-content/uploads/media";

		add_filter('the_content', array(&$this, '_filter'), -1);
		add_filter('the_excerpt', array(&$this, '_filter'), -1);
	}

	function _filter($content) {
		if($this->use_html_tag)
			$content = preg_replace('#<act(.*?)>(.*?)</act>#sie', '$this->get_script(\'$2\', \'$1\');', $content);
		$content = preg_replace('#\[act(.*?)\](.*?)\[/act\]#sie', '$this->get_script(\'$2\', \'$1\');', $content);
		return $content;
	}

	function get_script($url, $options) {
		global $doing_rss;
		if(is_feed() || $doing_rss)
			return '<p>[ Please visit <a href="'.get_permalink().'">blog</a> to view this video ]</p>';
		$options = str_replace(array("&#8216;", "&#8217;", "&#8242;"), "'", $options);
		$options = str_replace(array("&#8220;", "&#8221;", "&#8243;"), '"', $options);
		$options = str_replace(array("\\\"", "\\\'"), array("\"", "\'"), trim($options));
		$url = trim($url);
		$options = str_replace("'", '"', $options);
		$result = '';
		$type = '';
		$wh = false;
		$result = "<p class=\"mediafilter\">";
		if(preg_match('/type="([^"]*)"/i', $options, $match)) { 
			$type = trim($match[1]);
		} else {
			foreach($this->pre_url as $preurl) {
				if(stripos($url, $preurl) !== false) {
					$type = 'flv'; break;
				}
			}
		}
		if(!empty($type) && in_array($type, $this->preset)) {
				$url = $this->pre_url[$type].$url;
				$type = 'flv';
		} elseif(empty($type)) {
			if(strpos($url, 'http://') === FALSE && strpos($url, 'mms://') === FALSE) {
				$url = ltrim($url, '/');
				$url = trailingslashit($this->base).$url;
			}
			$type = explode(".", $url);
			$type = trim(strtolower($type[count($type) - 1]));
		}
		if($type == 'flv') {
			if(stripos($url, 'daum.net') !== false || stripos($url, 'hanmail.net') !== false) {
				$wh = true;
				if(stripos($url, 'sflvPlayer_full') !== false) { $width = '649'; $height = '509'; } 
				else { $width = '402'; $height = '324'; }
			} elseif (stripos($url, 'mncast.com') !== false) {
				$wh = true; $width = '420'; $height = '374';
			}
		}
		if(!$wh) {
			 if (preg_match('/w="(\d*?)"/i', $options, $match)) {
				  $width = (int)$match[1];
			 } else { $width = $this->width; }
			 if (preg_match('/h="(\d*?)"/i', $options, $match)) {
				  $height = (int)$match[1];
			 } else { $height = $this->height; }
			 if (preg_match('/auto="(\d*?)"/i', $options, $match)) {
				  $autostart = ( 0 == (int)$match[1] )? "0" : "1";
			 } else { $autostart = $this->autostart; }
		}
		$result .= $this->_replace_movie($type, $url, $width, $height, $autostart);
		$result .= "</p>";
		return $result;
	}

	function _replace_movie($type, $url, $width='', $height='', $autostart='') {
		$result = '';
		switch($type) {
			case 'flv':
				$result .= '<object type="application/x-shockwave-flash" data="'.$url.'" ';
				$result .= 'width="'.$width.'" height="'.$height.'">';
				$result .= '<param name="movie" value="'.$url.'" />';
				$result .= '<param name="quality" value="best" />';
				$result .= '<param name="scale" value="noScale" />';
				$result .= '<param name="FlashVars" value="playerMode=embedded" />';
				$result .= 'Browser does not supports flash video</object>';
			break;
			case 'swf':
				$result .= '<object type="application/x-shockwave-flash" data="'.$url.'" ';
				$result .= 'width="'.$width.'" height="'.$height.'">';
				$result .= '<param name="movie" value="'.$url.'" />';
				$result .= '<param name="allowScriptAcess" value="sameDomain" />';
				$result .= '<param name="quality" value="best" />';
				$result .= '<param name="wmode" value="opaque" />';
				$result .= '<param name="FlashVars" value="playerMode=embedded" />';
				$result .= 'Browser does not supports flash movie</object>';
			break;
			case 'mov':
			case 'mp4':
			case 'sdp':
				$result .= '<object type="video/quicktime" data="'.$url.'" width="'.$width.'" height="'.$height.'">';
				$result .= '<param name="src" value="'.$url.'" />';
				$result .= '<param name="controller" value="true" />';
				$result .= '<param name="autostart" value="'.$autostart.'" />';
				$result .= 'Browser does not supports quicktime movie</object>';
			break;
			case 'rm':
			case 'rmvb':
			case 'ra':
			case 'ram':
			case 'rv':
				$result .= '<object type="audio/x-pn-realaudio-plugin" data="'.$url.'" ';
				$result .= 'width="'.$width.'" height="'.$height.'">';
				$result .= '<param name="movie" value="'.$url.'" />';
				$result .= '<param name="controls" value="Imagewindow" />';
				$result .= '<param name="console" value="clip'.rand().'" />';
				$result .= '<param name="autostart" value="'.$autostart.'" />';
				$result .= 'Browser does not supports realmedia</object>';
			break;
			case 'wmv':
			case 'asf':
			case 'asx':
			default:
				//FIXME is there any way to embed wmv movie without IE hack?
				$result .= '<object data="'.$url.'" '.((strpos($_SERVER["HTTP_USER_AGENT"], 'MSIE') !== false)?'classid="clsid:22D6F312-B0F6-11D0-94AB-0080C74C7E95"':'type="application/x-mplayer2"');
				$result .= ' width="'.$width.'" height="'.$height.'">';
				$result .= '<param name="src" value="'.$url.'" />';
				$result .= '<param name="autostart" value="'.$autostart.'" />';
				$result .= 'Browser does not supports windows media</object>';
			break;
		}
		return $result;
	}

	function &get_instance() {
		static $instance = array();
		if ( empty( $instance ) ) {
			$instance[] =& new WpMediaFilter();
		}
		return $instance[0];
	}
}// end of class

$wpMediaFilter =& WpMediaFilter::get_instance();
?>